// -*- C++ -*-
//
// ChVolume - BVolume with indexing
//
// Copyright © 1997-1998 Arcane Dragon Software
//                       Chris Herborth (chrish@kagi.com)
//
// This is based on some APIs that existed in AADR9, but vanished in
// the Preview Release.
//
// $Id: ChVolume.h,v 1.7 1998/04/14 11:39:23 chrish Exp chrish $

#ifndef libCh_VOLUME_H
#define libCh_VOLUME_H

#pragma once

#include <support/SupportDefs.h>
#include <storage/Volume.h>
#include <kernel/fs_index.h>

class ChVolume : public BVolume
{
public:
#if __MWERKS__ >= 0x2010
	typedef BVolume inherited;
#endif

	ChVolume();
	ChVolume( dev_t dev );
	ChVolume( const BVolume &vol );
	ChVolume( const ChVolume &vol );

	virtual ~ChVolume();

	status_t AddIndex( const char *index, int type, uint flags );
	status_t RemoveIndex( const char *index );
	status_t GetIndexInfo( const char *index, struct index_info *info );
	status_t GetNextIndexName( char *buf );
	status_t RewindIndexList( void );

	ChVolume &operator=( const BVolume &vol );
	ChVolume &operator=( const ChVolume &vol );

private:
	ChVolume& operator=( ChVolume& );	// Don't assign me

	friend class BVolumeRoster;

	DIR *_index_dir;

	static char *_rcs_id;
};

#endif
