#! /bin/sh
#
# Install libCh.
#
# $Id: install.sh,v 1.2 1998/04/12 00:08:11 chrish Exp $

dest_prefix=/boot/home/config
trash_path=/boot/home/Desktop/Trash
npos_path=/boot/apps/NetPositive

do_an_error() {
	cat << HTMLEOF > /tmp/libCh_error.html
<html>
<head><title>libCh Installation Error</title></head>
<body bgcolor="#ffffcb">
<h1><tt>libCh</tt> Installation Error</h1>
<p>You must run <tt>install.sh</tt> from a Terminal in the <tt>libCh</tt>
directory.</p>
</body>
</html>
HTMLEOF
	$npos_path file:///tmp/libCh_error.html
	rm -f /tmp/libCh_error.html
	exit 1
}

echo "Checking for libCh files..."
if test ! -e include ; then
	echo "Can't find the include directory! ARGH!"
	do_an_error
fi
if test ! -e lib ; then
	echo "Can't find the lib directory! ARGH!"
	do_an_error
fi

echo "Installing libCh into $dest_prefix..."

if [ -e $dest_prefix/include/Ch ] ; then
	echo "Moving old libCh installation to the Trash..."
	mv -v $dest_prefix/include/Ch $trash_path
	mv -v $dest_prefix/lib/libCh.a $trash_path
fi

mkdir -p $dest_prefix/include/Ch
echo "Copying headers..."
cp -v include/Ch/*.h $dest_prefix/include/Ch/
for header_file in $dest_prefix/include/Ch/*.h ; do
	mimeset -f -all $header_file
done

mkdir -p $dest_prefix/lib
echo "Copying library..."
cp -v lib/libCh.a $dest_prefix/lib/
mimeset -f -all $dest_prefix/lib/libCh.a

echo "Done!"

$npos_path file://`pwd`/README.html &
