// test-ColorMap
//
// Copyright © 1997-1998 Arcane Dragon Software
//                       Chris Herborth (chrish@kagi.com)
//
// A fairly crappy test of the ChColorMap class.  Note the lack of a UI...

#include <stdio.h>
#include <app/Application.h>
#include <interface/InterfaceDefs.h>
#include "Ch/ChColorMap.h"

static char *_rcs_id = "$Id: test-ColorMap.cpp,v 1.3 1998/04/14 00:34:05 chrish Exp $";

int main( void )
{
	printf( "ChColorMap test\n" );
	printf( "%s\n", _rcs_id );
	printf( "\n" );

	BApplication app( "application/x-vnd.ads-colormap-test" );

	ChColorMap map;

	const color_map *c = system_colors();

	printf( "Here come the nearest greyscale equivalents for the system colours:\n" );

	unsigned int loop;
	unsigned int index;
	rgb_color new_c;

	for( loop = 0; loop < 256; loop++ ) {
		// Yes, I know this is a super-naive way of calculating the
		// greyscale value for an r,g,b; I couldn't find the real
		// equation on/in my desk/notebooks, and I didn't feel like
		// snooping around the 'net for a gimpy test program.
		unsigned char grey = ( c->color_list[loop].red 
							 + c->color_list[loop].green
							 + c->color_list[loop].blue ) / 3;

		index = map.GetIndex( grey, grey, grey );
		new_c = map.GetColor( grey, grey, grey );

		printf( "[%3d,%3d,%3d] = [%3d grey] = %3d:[%3d,%3d,%3d]\n",
			    c->color_list[loop].red,
			    c->color_list[loop].green,
			    c->color_list[loop].blue,
			    grey,
			    index,
			    new_c.red,
			    new_c.blue,
			    new_c.green );
	}

	printf( "----------------------------------------------------\n" );
	printf( "Here are the nearest system colours to all the reds:\n" );

	for( loop = 0; loop < 256; loop++ ) {
		index = map.GetIndex( loop, 0, 0 );
		new_c = map.GetColor( loop, 0, 0 );

		printf( "[%3d, 0, 0] = %3d:[%3d,%3d,%3d]\n",
			    loop,
			    index,
			    new_c.red,
			    new_c.blue,
			    new_c.green );
	}

	printf( "----------------------------------------------------\n" );
	printf( "Here are the nearest system colours to all the greens:\n" );

	for( loop = 0; loop < 256; loop++ ) {
		index = map.GetIndex( 0, loop, 0 );
		new_c = map.GetColor( 0, loop, 0 );

		printf( "[0, %3d, 0] = %3d:[%3d,%3d,%3d]\n",
			    loop,
			    index,
			    new_c.red,
			    new_c.blue,
			    new_c.green );
	}

	printf( "----------------------------------------------------\n" );
	printf( "Here are the nearest system colours to all the blues:\n" );

	for( loop = 0; loop < 256; loop++ ) {
		index = map.GetIndex( 0, 0, loop );
		new_c = map.GetColor( 0, 0, loop );

		printf( "[0, 0, %3d] = %3d:[%3d,%3d,%3d]\n",
			    loop,
			    index,
			    new_c.red,
			    new_c.blue,
			    new_c.green );
	}

	app.PostMessage( B_QUIT_REQUESTED );
	app.Run();

	return B_NO_ERROR;
}
